; XIVO Dialplan
; Copyright (C) 2006-2015  Avencall
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License along
; with this program; if not, write to the Free Software Foundation, Inc.,
; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

; params:
;  1 queue ID
;  2 dial timeout
[queue]
; PRIORITY OF XIVO_DSTID= MUST BE 1 ; DON'T MODIFY
exten = s,1,Set(XIVO_DSTID=${ARG1})
same  =   n,Set(XIVO_PRESUBR_GLOBAL_NAME=QUEUE)
same  =   n,Set(XIVO_QUEUELOG_EVENT=)
same  =   n,UserEvent(Queue,CHANNEL: ${CHANNEL},XIVO_USERID: ${XIVO_USERID},XIVO_DSTID: ${XIVO_DSTID},XIVO_CALLERIDNAME: ${CALLERID(name)},XIVO_CALLERIDNUMBER: ${CALLERID(num)})
same  =   n,Set(XIVO_SRCNUM=${IF(${EXISTS(${XIVO_SRCNUM})}?${XIVO_SRCNUM}:${CALLERID(num)})})
same  =   n,Set(XIVO_DSTNUM=${IF(${EXISTS(${XIVO_DSTNUM})}?${XIVO_DSTNUM}:${XIVO_BASE_EXTEN})})
same  =   n,Set(XIVO_CONTEXT=${IF(${EXISTS(${XIVO_CONTEXT})}?${XIVO_CONTEXT}:${XIVO_BASE_CONTEXT})})
same  =   n,Set(__XIVO_FWD_REFERER=${IF(${EXISTS(${XIVO_FWD_REFERER})}?"${XIVO_FWD_REFERER}":queue:${ARG1})})
same  =   n,NoOp(PATH=${XIVO_PATH}/${XIVO_PATH_ID})
same  =   n,Gosub(originate-caller-id,s,1)
same  =   n,AGI(agi://${XIVO_AGID_IP}/incoming_queue_set_features)
same  =   n,NoOp(PATH=${XIVO_PATH}/${XIVO_PATH_ID})

; schedule
same  =   n,AGI(agi://${XIVO_AGID_IP}/check_schedule)
same  =   n,NoOp(QSTATUS=${XIVO_SCHEDULE_STATUS})
same  =   n,GotoIf($["${XIVO_SCHEDULE_STATUS}" = "closed"]?CLOSED,1)

; diversion
;   set QUEUEHOLDTIME variable
same  =   n,Set(_err=${QUEUE_VARIABLES(${XIVO_QUEUENAME})})

; queue statistics
same  =   n,AGI(agi://${XIVO_AGID_IP}/check_diversion)
same  =   n,GotoIf(${XIVO_DIVERT_EVENT}?DIVERT,1)
same  =   n,Set(__XIVO_FROMQUEUE=1)

; queue recording
; Note for first GotoIf: if XIVO_RECORDING_MODE is already set it means that a call to a queue
; was direct transferred to this other queue.
; In this case, if previous queue was in "notrecorded" mode, keep this mode.
same  =   n,GotoIf($["${XIVO_RECORDING_MODE}" = "notrecorded"]?norecord:)
same  =   n,AGI(agi://${XIVO_AGID_IP}/recording_mode_to_apply,${XIVO_DSTID})
same  =   n,GotoIf($["${XIVO_RECORDING_MODE}" == "false"]?norecord)
same  =   n,GotoIf($["${XIVO_RECORDING_MODE}" == "notrecorded"]?norecord)
same  =   n,GosubIf(${VALID_EXTEN(xivocc-queue-recording,s)}?xivocc-queue-recording,s,1:norecord)
same  =   n(norecord),Set(__XIVO_RECORDING_MODE=${XIVO_RECORDING_MODE})

same  =   n,GoSub(xivo-subroutine,s,1(${XIVO_QUEUEPREPROCESS_SUBROUTINE}))
same  =   n,Set(XIVO_QUEUETIMEOUT=${IF($["${ARG2}" != ""]?${ARG2}:${XIVO_QUEUETIMEOUT})})

; announcing holdtime
same  =   n,AGI(agi://${XIVO_AGID_IP}/holdtime_announce)

same  =   n,GosubIf(${XIVO_QUEUENEEDANSWER}?xivo-pickup,0,1)

; set call groups (XIVO_CALLGROUP setted in incoming_queue_set_features AGI)
; placed just before entering queue (starting ringing queue members)
same  =   n,GotoIf($["${XIVO_PICKUPGROUP}" = ""]?$[${PRIORITY} + 2])
same  =   n,Set(CHANNEL(callgroup)=${XIVO_PICKUPGROUP})
same  =   n,Gosub(xivo-global-subroutine,s,1)
same  =   n,Set(XIVO_EFFECTIVE_QUEUESKILLRULESET=${XIVO_QUEUESKILLRULESET})
same  =   n,Set(XIVO_QUEUESKILLRULESET=)
same  =   n,Set(_XIVO_QUEUEOPTIONS=${XIVO_QUEUEOPTIONS})
same  =   n,Queue(${XIVO_QUEUENAME},${XIVO_QUEUEOPTIONS},${XIVO_QUEUEURL},${XIVO_QUEUEANNOUNCEOVERRIDE},${XIVO_QUEUETIMEOUT},${XIVO_QUEUEAGI},${XIVO_QUEUESUB},${XIVO_PENALTYRULE},${XIVO_QUEUEPOSITION},${XIVO_EFFECTIVE_QUEUESKILLRULESET})
same  =   n,Goto(${QUEUESTATUS},1)

exten = CLOSED,1,Set(XIVO_FWD_TYPE=SCHEDULE_OUT)
same  =        n,Set(XIVO_QUEUELOG_EVENT=CLOSED)
same  =        n,Playback(queue-closed)
same  =        n,Goto(forward,1)

exten = DIVERT,1,Set(XIVO_QUEUELOG_EVENT=${XIVO_DIVERT_EVENT})
same  =        n,Playback(queue-diverted)
same  =        n,Goto(forward,1)

exten = TIMEOUT,1,Set(XIVO_FWD_TYPE=QUEUE_NOANSWER)
same  =         n,Playback(queue-timeout)
same  =         n,Goto(forward,1)

exten = FULL,1,Set(XIVO_FWD_TYPE=QUEUE_CONGESTION)
same  =      n,Set(XIVO_QUEUELOG_EVENT=FULL)
same  =      n,Playback(queue-full)
same  =      n,Goto(forward,1)

exten = JOINEMPTY,1,Set(XIVO_FWD_TYPE=QUEUE_CHANUNAVAIL)
same  =           n,Set(XIVO_QUEUELOG_EVENT=JOINEMPTY)
same  =           n,Goto(forward,1)

exten = LEAVEEMPTY,1,Set(XIVO_FWD_TYPE=QUEUE_CHANUNAVAIL)
same  =            n,Set(XIVO_QUEUELOG_EVENT=LEAVEEMPTY)
same  =            n,Goto(forward,1)

exten = CONTINUE,1,Set(XIVO_FWD_TYPE=QUEUE_CHANUNAVAIL)
same  =          n,Goto(forward,1)

exten = forward,1,Set(__XIVO_CALLFORWARDED=1)
same  =         n,GotoIf($["x${XIVO_QUEUELOG_EVENT}" = "x"]?noqueuelog)
same  =         n,QueueLog(${XIVO_QUEUENAME},${UNIQUEID},NONE,${XIVO_QUEUELOG_EVENT})
same  =         n(noqueuelog),Gosub(forward,s,1(${XIVO_FWD_${XIVO_FWD_TYPE}_ACTION},${XIVO_FWD_${XIVO_FWD_TYPE}_ACTIONARG1},${XIVO_FWD_${XIVO_FWD_TYPE}_ACTIONARG2}))
same  =         n,Hangup()
